#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
  QMainWindow(parent),
  ui(new Ui::MainWindow)
{
  ui->setupUi(this);
  //QObject::connect(ui->pushButton_2, SIGNAL(clicked()), ui->checkBox, SLOT(toggle()));
}

MainWindow::~MainWindow()
{
  delete ui;
}

const QObject* MainWindow::findObject(const QObject* owner, QString objectName)
{
  const QObjectList& list = owner->children();
  int _count = list.count();
  for (int i = 0; i < _count; i++)
  {
    const QObject* object = list.at(i);
    if (object->objectName() == objectName) return object;
    const QObject* res = findObject(object, objectName);
    if (res != NULL) return res;
  }
  return NULL;
}

bool MainWindow::findMethod(const QObject* object, QString methodName, QMetaMethod& method)
{
  int _count = object->metaObject()->methodCount();
  for (int i = 0; i < _count; i++)
  {
    QMetaMethod _method = object->metaObject()->method(i);
    LOG_DEBUG("%d %s", i, _method.signature());
    if (QString(_method.signature()) == methodName)
    {
      method = _method;
      return true;
    }
  }
  return false;
}

void MainWindow::on_pushButton_clicked()
{
  const QObject* sender = findObject(this, ui->lineEdit->text());
  if (sender == NULL) return;

  QMetaMethod signal;
  if (!findMethod(sender, ui->lineEdit_2->text(), signal)) return;

  const QObject* receiver = findObject(this, ui->lineEdit_3->text());
  if (sender == NULL) return;

  QMetaMethod slot;
  if (!findMethod(receiver, ui->lineEdit_4->text(), slot)) return;

  bool res = QObject::connect(sender, signal, receiver, slot);
  LOG_DEBUG("connect return %d", (int)res);
}
